/* Indicator.c generated by valac 0.56.2, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
* Copyright 2015-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "sound.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <libnotify/notify.h>
#include <float.h>
#include <math.h>
#include <canberra.h>
#include <wingpanel.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <pulse/pulseaudio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <locale.h>
#include <canberra-gtk.h>
#include <gmodule.h>

#define SOUND_INDICATOR_VOLUME_STEP_PERCENTAGE 0.06

enum  {
	SOUND_INDICATOR_0_PROPERTY,
	SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY,
	SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY,
	SOUND_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* sound_indicator_properties[SOUND_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _SoundIndicatorPrivate {
	gboolean _natural_scroll_touchpad;
	gboolean _natural_scroll_mouse;
	DisplayWidget* display_widget;
	GtkGrid* main_grid;
	SoundWidgetsPlayerList* mpris;
	SoundWidgetsScale* volume_scale;
	SoundWidgetsScale* mic_scale;
	SoundWidgetsDeviceManagerWidget* output_device_manager;
	SoundWidgetsDeviceManagerWidget* input_device_manager;
	GtkSeparator* mic_separator;
	NotifyNotification* notification;
	SoundServicesVolumeControlPulse* volume_control;
	gboolean open;
	gboolean mute_blocks_sound;
	guint sound_was_blocked_timeout_id;
	gdouble max_volume;
	ca_context* ca_context;
	gdouble total_x_delta;
	gdouble total_y_delta;
	guint notify_timeout_id;
};

struct _Block1Data {
	int _ref_count_;
	SoundIndicator* self;
	gboolean is_mic;
};

static gint SoundIndicator_private_offset;
static gpointer sound_indicator_parent_class = NULL;
GSettings* sound_indicator_settings = NULL;

static void sound_indicator_set_max_volume (SoundIndicator* self);
static void sound_indicator_on_volume_change (SoundIndicator* self);
static const gchar* sound_indicator_get_volume_icon (SoundIndicator* self,
                                              gdouble volume);
static void sound_indicator_on_mic_volume_change (SoundIndicator* self);
static void sound_indicator_on_mute_change (SoundIndicator* self);
static void sound_indicator_on_mic_mute_change (SoundIndicator* self);
static void sound_indicator_on_is_playing_change (SoundIndicator* self);
static gboolean ____lambda55_ (SoundIndicator* self);
static gboolean _____lambda55__gsource_func (gpointer self);
static void sound_indicator_on_volume_icon_scroll_event (SoundIndicator* self,
                                                  GdkEventScroll* e);
static gboolean sound_indicator_handle_scroll_event (SoundIndicator* self,
                                              GdkEventScroll* e,
                                              gdouble* dir);
static void sound_indicator_handle_change (SoundIndicator* self,
                                    gdouble change,
                                    gboolean is_mic);
static void sound_indicator_on_mic_icon_scroll_event (SoundIndicator* self,
                                               GdkEventScroll* e);
static void sound_indicator_update_mic_visibility (SoundIndicator* self);
static void sound_indicator_on_volume_switch_change (SoundIndicator* self);
static void sound_indicator_on_mic_switch_change (SoundIndicator* self);
static GtkWidget* sound_indicator_real_get_display_widget (WingpanelIndicator* base);
static GtkWidget* sound_indicator_real_get_widget (WingpanelIndicator* base);
static void _sound_indicator_on_mic_switch_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void ___lambda57_ (SoundIndicator* self);
static void ____lambda57__gtk_range_value_changed (GtkRange* _sender,
                                            gpointer self);
static gboolean ___lambda58_ (SoundIndicator* self);
static void sound_indicator_notify_change (SoundIndicator* self,
                                    gboolean is_mic);
static gboolean ____lambda58__gtk_widget_button_release_event (GtkWidget* _sender,
                                                        GdkEventButton* event,
                                                        gpointer self);
static gboolean ___lambda59_ (SoundIndicator* self,
                       GdkEventScroll* e);
static gboolean ____lambda59__gtk_widget_scroll_event (GtkWidget* _sender,
                                                GdkEventScroll* event,
                                                gpointer self);
static void ___lambda60_ (SoundIndicator* self);
static void ____lambda60__sound_widgets_player_list_close (SoundWidgetsPlayerList* _sender,
                                                    gpointer self);
static void ___lambda61_ (SoundIndicator* self);
static void sound_indicator_show_settings (SoundIndicator* self);
static void ____lambda61__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void ___lambda62_ (SoundIndicator* self);
static void ____lambda62__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static gboolean ___lambda63_ (SoundIndicator* self,
                       GdkEventButton* e);
static gboolean ____lambda63__gtk_widget_button_release_event (GtkWidget* _sender,
                                                        GdkEventButton* event,
                                                        gpointer self);
static gboolean ___lambda64_ (SoundIndicator* self,
                       GdkEventScroll* e);
static gboolean ____lambda64__gtk_widget_scroll_event (GtkWidget* _sender,
                                                GdkEventScroll* event,
                                                gpointer self);
static void _sound_indicator_on_volume_switch_change_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void ___lambda65_ (SoundIndicator* self);
static void ____lambda65__gtk_range_value_changed (GtkRange* _sender,
                                            gpointer self);
static void sound_indicator_real_opened (WingpanelIndicator* base);
static void sound_indicator_real_closed (WingpanelIndicator* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda56_ (Block1Data* _data1_);
static gboolean sound_indicator_show_notification (SoundIndicator* self,
                                            gboolean is_mic);
static gboolean ___lambda56__gsource_func (gpointer self);
static void sound_indicator_update_tooltip (SoundIndicator* self);
static GObject * sound_indicator_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _sound_indicator_on_volume_change_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _sound_indicator_on_mic_volume_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _sound_indicator_on_mute_change_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator_on_mic_mute_change_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _sound_indicator_on_is_playing_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _sound_indicator_update_mic_visibility_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void _sound_indicator_update_tooltip_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator_set_max_volume_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator___lambda66_ (SoundIndicator* self,
                                   GdkEventButton* e);
static void __sound_indicator___lambda66__display_widget_volume_press_event (DisplayWidget* _sender,
                                                                      GdkEventButton* e,
                                                                      gpointer self);
static void _sound_indicator___lambda67_ (SoundIndicator* self,
                                   GdkEventButton* e);
static void __sound_indicator___lambda67__display_widget_mic_press_event (DisplayWidget* _sender,
                                                                   GdkEventButton* e,
                                                                   gpointer self);
static void _sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event (DisplayWidget* _sender,
                                                                                      GdkEventScroll* e,
                                                                                      gpointer self);
static void _sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event (DisplayWidget* _sender,
                                                                                GdkEventScroll* e,
                                                                                gpointer self);
static void sound_indicator_finalize (GObject * obj);
static GType sound_indicator_get_type_once (void);
static void _vala_sound_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_sound_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
sound_indicator_get_instance_private (SoundIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, SoundIndicator_private_offset);
}

SoundIndicator*
sound_indicator_construct (GType object_type)
{
	SoundIndicator * self = NULL;
	self = (SoundIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_SOUND, NULL);
	return self;
}

SoundIndicator*
sound_indicator_new (void)
{
	return sound_indicator_construct (SOUND_TYPE_INDICATOR);
}

static void
sound_indicator_set_max_volume (SoundIndicator* self)
{
	gdouble max = 0.0;
	GSettings* _tmp0_;
	gdouble cap_volume = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = sound_indicator_settings;
	max = g_settings_get_double (_tmp0_, "max-volume") / 100;
	cap_volume = ((gdouble) pa_sw_volume_from_dB (11.0)) / PA_VOLUME_NORM;
	if (max > cap_volume) {
		max = cap_volume;
	}
	self->priv->max_volume = max;
	sound_indicator_on_volume_change (self);
}

static void
sound_indicator_on_volume_change (SoundIndicator* self)
{
	gdouble volume = 0.0;
	SoundServicesVolumeControlPulse* _tmp0_;
	SoundServicesVolumeControlVolume* _tmp1_;
	SoundServicesVolumeControlVolume* _tmp2_;
	SoundWidgetsScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->volume_control;
	_tmp1_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp0_);
	_tmp2_ = _tmp1_;
	volume = _tmp2_->volume / self->priv->max_volume;
	_tmp3_ = self->priv->volume_scale;
	_tmp4_ = sound_widgets_scale_get_scale_widget (_tmp3_);
	_tmp5_ = _tmp4_;
	if (volume != gtk_range_get_value ((GtkRange*) _tmp5_)) {
		SoundWidgetsScale* _tmp6_;
		GtkScale* _tmp7_;
		GtkScale* _tmp8_;
		DisplayWidget* _tmp9_;
		const gchar* _tmp10_;
		_tmp6_ = self->priv->volume_scale;
		_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
		_tmp8_ = _tmp7_;
		gtk_range_set_value ((GtkRange*) _tmp8_, volume);
		_tmp9_ = self->priv->display_widget;
		_tmp10_ = sound_indicator_get_volume_icon (self, volume);
		display_widget_set_icon_name (_tmp9_, _tmp10_);
	}
}

static void
sound_indicator_on_mic_volume_change (SoundIndicator* self)
{
	gdouble volume = 0.0;
	SoundServicesVolumeControlPulse* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	SoundWidgetsScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->volume_control;
	_tmp1_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp0_);
	_tmp2_ = _tmp1_;
	volume = _tmp2_;
	_tmp3_ = self->priv->mic_scale;
	_tmp4_ = sound_widgets_scale_get_scale_widget (_tmp3_);
	_tmp5_ = _tmp4_;
	if (volume != gtk_range_get_value ((GtkRange*) _tmp5_)) {
		SoundWidgetsScale* _tmp6_;
		GtkScale* _tmp7_;
		GtkScale* _tmp8_;
		_tmp6_ = self->priv->mic_scale;
		_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
		_tmp8_ = _tmp7_;
		gtk_range_set_value ((GtkRange*) _tmp8_, volume);
	}
}

static void
sound_indicator_on_mute_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* volume_icon = NULL;
	SoundServicesVolumeControlPulse* _tmp4_;
	SoundServicesVolumeControlVolume* _tmp5_;
	SoundServicesVolumeControlVolume* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	DisplayWidget* _tmp9_;
	const gchar* _tmp10_;
	SoundServicesVolumeControlPulse* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->volume_scale;
	_tmp1_ = self->priv->volume_control;
	_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
	_tmp3_ = _tmp2_;
	sound_widgets_scale_set_active (_tmp0_, !_tmp3_);
	_tmp4_ = self->priv->volume_control;
	_tmp5_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = sound_indicator_get_volume_icon (self, _tmp6_->volume);
	_tmp8_ = g_strdup (_tmp7_);
	volume_icon = _tmp8_;
	_tmp9_ = self->priv->display_widget;
	_tmp10_ = volume_icon;
	display_widget_set_icon_name (_tmp9_, _tmp10_);
	_tmp11_ = self->priv->volume_control;
	_tmp12_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp11_);
	_tmp13_ = _tmp12_;
	if (_tmp13_) {
		SoundWidgetsScale* _tmp14_;
		_tmp14_ = self->priv->volume_scale;
		sound_widgets_scale_set_icon (_tmp14_, "audio-volume-muted-symbolic");
	} else {
		SoundWidgetsScale* _tmp15_;
		const gchar* _tmp16_;
		_tmp15_ = self->priv->volume_scale;
		_tmp16_ = volume_icon;
		sound_widgets_scale_set_icon (_tmp15_, _tmp16_);
	}
	_g_free0 (volume_icon);
}

static void
sound_indicator_on_mic_mute_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	DisplayWidget* _tmp4_;
	SoundServicesVolumeControlPulse* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundServicesVolumeControlPulse* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mic_scale;
	_tmp1_ = self->priv->volume_control;
	_tmp2_ = sound_services_volume_control_pulse_get_micMute (_tmp1_);
	_tmp3_ = _tmp2_;
	sound_widgets_scale_set_active (_tmp0_, !_tmp3_);
	_tmp4_ = self->priv->display_widget;
	_tmp5_ = self->priv->volume_control;
	_tmp6_ = sound_services_volume_control_pulse_get_micMute (_tmp5_);
	_tmp7_ = _tmp6_;
	display_widget_set_mic_muted (_tmp4_, _tmp7_);
	_tmp8_ = self->priv->volume_control;
	_tmp9_ = sound_services_volume_control_pulse_get_micMute (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		SoundWidgetsScale* _tmp11_;
		_tmp11_ = self->priv->mic_scale;
		sound_widgets_scale_set_icon (_tmp11_, "microphone-sensitivity-muted-symbolic");
	} else {
		SoundWidgetsScale* _tmp12_;
		_tmp12_ = self->priv->mic_scale;
		sound_widgets_scale_set_icon (_tmp12_, "audio-input-microphone-symbolic");
	}
}

static gboolean
____lambda55_ (SoundIndicator* self)
{
	DisplayWidget* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	SoundServicesVolumeControlVolume* _tmp2_;
	SoundServicesVolumeControlVolume* _tmp3_;
	const gchar* _tmp4_;
	gboolean result;
	self->priv->mute_blocks_sound = FALSE;
	self->priv->sound_was_blocked_timeout_id = (guint) 0;
	_tmp0_ = self->priv->display_widget;
	_tmp1_ = self->priv->volume_control;
	_tmp2_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = sound_indicator_get_volume_icon (self, _tmp3_->volume);
	display_widget_set_icon_name (_tmp0_, _tmp4_);
	result = FALSE;
	return result;
}

static gboolean
_____lambda55__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda55_ ((SoundIndicator*) self);
	return result;
}

static void
sound_indicator_on_is_playing_change (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SoundServicesVolumeControlPulse* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	DisplayWidget* _tmp6_;
	SoundServicesVolumeControlPulse* _tmp7_;
	SoundServicesVolumeControlVolume* _tmp8_;
	SoundServicesVolumeControlVolume* _tmp9_;
	const gchar* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->volume_control;
	_tmp1_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		self->priv->mute_blocks_sound = FALSE;
		return;
	}
	_tmp3_ = self->priv->volume_control;
	_tmp4_ = sound_services_volume_control_get_is_playing ((SoundServicesVolumeControl*) _tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		self->priv->mute_blocks_sound = TRUE;
	} else {
		if (self->priv->mute_blocks_sound) {
			if (self->priv->sound_was_blocked_timeout_id > ((guint) 0)) {
				g_source_remove (self->priv->sound_was_blocked_timeout_id);
			}
			self->priv->sound_was_blocked_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, _____lambda55__gsource_func, g_object_ref (self), g_object_unref);
		}
	}
	_tmp6_ = self->priv->display_widget;
	_tmp7_ = self->priv->volume_control;
	_tmp8_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = sound_indicator_get_volume_icon (self, _tmp9_->volume);
	display_widget_set_icon_name (_tmp6_, _tmp10_);
}

static void
sound_indicator_on_volume_icon_scroll_event (SoundIndicator* self,
                                             GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (e != NULL);
	dir = 0.0;
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
	dir = _tmp0_;
	if (_tmp1_) {
		sound_indicator_handle_change (self, dir, FALSE);
	}
}

static void
sound_indicator_on_mic_icon_scroll_event (SoundIndicator* self,
                                          GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (e != NULL);
	dir = 0.0;
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
	dir = _tmp0_;
	if (_tmp1_) {
		sound_indicator_handle_change (self, dir, TRUE);
	}
}

static void
sound_indicator_update_mic_visibility (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->volume_control;
	_tmp1_ = sound_services_volume_control_get_is_listening ((SoundServicesVolumeControl*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		SoundWidgetsScale* _tmp3_;
		SoundWidgetsScale* _tmp4_;
		GtkSeparator* _tmp5_;
		GtkSeparator* _tmp6_;
		SoundWidgetsDeviceManagerWidget* _tmp7_;
		SoundWidgetsDeviceManagerWidget* _tmp8_;
		DisplayWidget* _tmp9_;
		_tmp3_ = self->priv->mic_scale;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp3_, FALSE);
		_tmp4_ = self->priv->mic_scale;
		gtk_widget_show_all ((GtkWidget*) _tmp4_);
		_tmp5_ = self->priv->mic_separator;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, FALSE);
		_tmp6_ = self->priv->mic_separator;
		gtk_widget_show ((GtkWidget*) _tmp6_);
		_tmp7_ = self->priv->input_device_manager;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp7_, FALSE);
		_tmp8_ = self->priv->input_device_manager;
		gtk_widget_show ((GtkWidget*) _tmp8_);
		_tmp9_ = self->priv->display_widget;
		display_widget_set_show_mic (_tmp9_, TRUE);
	} else {
		SoundWidgetsScale* _tmp10_;
		SoundWidgetsScale* _tmp11_;
		GtkSeparator* _tmp12_;
		GtkSeparator* _tmp13_;
		SoundWidgetsDeviceManagerWidget* _tmp14_;
		SoundWidgetsDeviceManagerWidget* _tmp15_;
		DisplayWidget* _tmp16_;
		_tmp10_ = self->priv->mic_scale;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
		_tmp11_ = self->priv->mic_scale;
		gtk_widget_hide ((GtkWidget*) _tmp11_);
		_tmp12_ = self->priv->mic_separator;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp12_, TRUE);
		_tmp13_ = self->priv->mic_separator;
		gtk_widget_hide ((GtkWidget*) _tmp13_);
		_tmp14_ = self->priv->input_device_manager;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp14_, TRUE);
		_tmp15_ = self->priv->input_device_manager;
		gtk_widget_hide ((GtkWidget*) _tmp15_);
		_tmp16_ = self->priv->display_widget;
		display_widget_set_show_mic (_tmp16_, FALSE);
	}
}

static const gchar*
sound_indicator_get_volume_icon (SoundIndicator* self,
                                 gdouble volume)
{
	gboolean _tmp0_ = FALSE;
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (volume <= ((gdouble) 0)) {
		_tmp0_ = TRUE;
	} else {
		SoundServicesVolumeControlPulse* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp1_ = self->priv->volume_control;
		_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	}
	if (_tmp0_) {
		const gchar* _tmp4_ = NULL;
		if (self->priv->mute_blocks_sound) {
			_tmp4_ = "audio-volume-muted-blocking-symbolic";
		} else {
			_tmp4_ = "audio-volume-muted-symbolic";
		}
		result = _tmp4_;
		return result;
	} else {
		if (volume <= 0.3) {
			result = "audio-volume-low-symbolic";
			return result;
		} else {
			if (volume <= 0.7) {
				result = "audio-volume-medium-symbolic";
				return result;
			} else {
				result = "audio-volume-high-symbolic";
				return result;
			}
		}
	}
}

static void
sound_indicator_on_volume_switch_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->volume_scale;
	_tmp1_ = sound_widgets_scale_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		SoundServicesVolumeControlPulse* _tmp3_;
		_tmp3_ = self->priv->volume_control;
		sound_services_volume_control_set_mute ((SoundServicesVolumeControl*) _tmp3_, FALSE);
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
		_tmp4_ = self->priv->volume_control;
		sound_services_volume_control_set_mute ((SoundServicesVolumeControl*) _tmp4_, TRUE);
	}
}

static void
sound_indicator_on_mic_switch_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mic_scale;
	_tmp1_ = sound_widgets_scale_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		SoundServicesVolumeControlPulse* _tmp3_;
		_tmp3_ = self->priv->volume_control;
		sound_services_volume_control_pulse_set_mic_mute (_tmp3_, FALSE);
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
		_tmp4_ = self->priv->volume_control;
		sound_services_volume_control_pulse_set_mic_mute (_tmp4_, TRUE);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
sound_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	SoundIndicator * self;
	DisplayWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result;
	self = (SoundIndicator*) base;
	_tmp0_ = self->priv->display_widget;
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
	result = _tmp1_;
	return result;
}

static void
_sound_indicator_on_mic_switch_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
	sound_indicator_on_mic_switch_change ((SoundIndicator*) self);
}

static void
___lambda57_ (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	SoundWidgetsScale* _tmp1_;
	GtkScale* _tmp2_;
	GtkScale* _tmp3_;
	_tmp0_ = self->priv->volume_control;
	_tmp1_ = self->priv->mic_scale;
	_tmp2_ = sound_widgets_scale_get_scale_widget (_tmp1_);
	_tmp3_ = _tmp2_;
	sound_services_volume_control_set_mic_volume ((SoundServicesVolumeControl*) _tmp0_, gtk_range_get_value ((GtkRange*) _tmp3_));
}

static void
____lambda57__gtk_range_value_changed (GtkRange* _sender,
                                       gpointer self)
{
	___lambda57_ ((SoundIndicator*) self);
}

static gboolean
___lambda58_ (SoundIndicator* self)
{
	gboolean result;
	sound_indicator_notify_change (self, TRUE);
	result = FALSE;
	return result;
}

static gboolean
____lambda58__gtk_widget_button_release_event (GtkWidget* _sender,
                                               GdkEventButton* event,
                                               gpointer self)
{
	gboolean result;
	result = ___lambda58_ ((SoundIndicator*) self);
	return result;
}

static gboolean
___lambda59_ (SoundIndicator* self,
              GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
	g_return_val_if_fail (e != NULL, FALSE);
	dir = 0.0;
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
	dir = _tmp0_;
	if (_tmp1_) {
		sound_indicator_handle_change (self, dir, TRUE);
	}
	result = TRUE;
	return result;
}

static gboolean
____lambda59__gtk_widget_scroll_event (GtkWidget* _sender,
                                       GdkEventScroll* event,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda59_ ((SoundIndicator*) self, event);
	return result;
}

static void
___lambda60_ (SoundIndicator* self)
{
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
}

static void
____lambda60__sound_widgets_player_list_close (SoundWidgetsPlayerList* _sender,
                                               gpointer self)
{
	___lambda60_ ((SoundIndicator*) self);
}

static void
___lambda61_ (SoundIndicator* self)
{
	sound_indicator_show_settings (self);
}

static void
____lambda61__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
	___lambda61_ ((SoundIndicator*) self);
}

static void
___lambda62_ (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->volume_control;
	_tmp1_ = sound_services_volume_control_get_headphone_plugged ((SoundServicesVolumeControl*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		SoundWidgetsPlayerList* _tmp3_;
		_tmp3_ = self->priv->mpris;
		sound_widgets_player_list_pause_all (_tmp3_);
	}
}

static void
____lambda62__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda62_ ((SoundIndicator*) self);
}

static gboolean
___lambda63_ (SoundIndicator* self,
              GdkEventButton* e)
{
	gboolean result;
	g_return_val_if_fail (e != NULL, FALSE);
	sound_indicator_notify_change (self, FALSE);
	result = FALSE;
	return result;
}

static gboolean
____lambda63__gtk_widget_button_release_event (GtkWidget* _sender,
                                               GdkEventButton* event,
                                               gpointer self)
{
	gboolean result;
	result = ___lambda63_ ((SoundIndicator*) self, event);
	return result;
}

static gboolean
___lambda64_ (SoundIndicator* self,
              GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
	g_return_val_if_fail (e != NULL, FALSE);
	dir = 0.0;
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
	dir = _tmp0_;
	if (_tmp1_) {
		sound_indicator_handle_change (self, dir, FALSE);
	}
	result = TRUE;
	return result;
}

static gboolean
____lambda64__gtk_widget_scroll_event (GtkWidget* _sender,
                                       GdkEventScroll* event,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda64_ ((SoundIndicator*) self, event);
	return result;
}

static void
_sound_indicator_on_volume_switch_change_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
	sound_indicator_on_volume_switch_change ((SoundIndicator*) self);
}

static void
___lambda65_ (SoundIndicator* self)
{
	SoundServicesVolumeControlVolume* vol = NULL;
	SoundServicesVolumeControlVolume* _tmp0_;
	gdouble v = 0.0;
	SoundWidgetsScale* _tmp1_;
	GtkScale* _tmp2_;
	GtkScale* _tmp3_;
	SoundServicesVolumeControlPulse* _tmp4_;
	SoundWidgetsScale* _tmp5_;
	SoundWidgetsScale* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	const gchar* _tmp9_;
	_tmp0_ = sound_services_volume_control_volume_new ();
	vol = _tmp0_;
	_tmp1_ = self->priv->volume_scale;
	_tmp2_ = sound_widgets_scale_get_scale_widget (_tmp1_);
	_tmp3_ = _tmp2_;
	v = gtk_range_get_value ((GtkRange*) _tmp3_) * self->priv->max_volume;
	vol->volume = CLAMP (v, 0.0, self->priv->max_volume);
	vol->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS;
	_tmp4_ = self->priv->volume_control;
	sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) _tmp4_, vol);
	_tmp5_ = self->priv->volume_scale;
	_tmp6_ = self->priv->volume_scale;
	_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp8_));
	sound_widgets_scale_set_icon (_tmp5_, _tmp9_);
	_g_object_unref0 (vol);
}

static void
____lambda65__gtk_range_value_changed (GtkRange* _sender,
                                       gpointer self)
{
	___lambda65_ ((SoundIndicator*) self);
}

static GtkWidget*
sound_indicator_real_get_widget (WingpanelIndicator* base)
{
	SoundIndicator * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp64_;
	GtkWidget* _tmp65_;
	GtkWidget* result;
	self = (SoundIndicator*) base;
	_tmp0_ = self->priv->main_grid;
	if (_tmp0_ == NULL) {
		SoundWidgetsPlayerList* _tmp1_;
		SoundWidgetsScale* _tmp2_;
		SoundServicesVolumeControlPulse* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		SoundWidgetsScale* _tmp6_;
		GtkScale* _tmp7_;
		GtkScale* _tmp8_;
		SoundServicesVolumeControlPulse* _tmp9_;
		SoundServicesVolumeControlVolume* _tmp10_;
		SoundServicesVolumeControlVolume* _tmp11_;
		SoundWidgetsScale* _tmp12_;
		SoundWidgetsScale* _tmp13_;
		GtkScale* _tmp14_;
		GtkScale* _tmp15_;
		const gchar* _tmp16_;
		SoundWidgetsScale* _tmp17_;
		SoundServicesVolumeControlPulse* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
		GtkSeparator* _tmp21_;
		GtkModelButton* settings_button = NULL;
		gchar* _tmp22_;
		GtkModelButton* _tmp23_ = NULL;
		GtkGrid* _tmp24_;
		GtkGrid* _tmp25_;
		SoundWidgetsPlayerList* _tmp26_;
		GtkGrid* _tmp27_;
		GtkSeparator* _tmp28_;
		GtkSeparator* _tmp29_;
		GtkGrid* _tmp30_;
		SoundWidgetsScale* _tmp31_;
		GtkGrid* _tmp32_;
		SoundWidgetsDeviceManagerWidget* _tmp33_;
		GtkGrid* _tmp34_;
		GtkSeparator* _tmp35_;
		GtkSeparator* _tmp36_;
		GtkGrid* _tmp37_;
		SoundWidgetsScale* _tmp38_;
		GtkGrid* _tmp39_;
		SoundWidgetsDeviceManagerWidget* _tmp40_;
		GtkGrid* _tmp41_;
		GtkSeparator* _tmp42_;
		GtkGrid* _tmp43_;
		GtkModelButton* _tmp44_;
		SoundWidgetsScale* _tmp45_;
		SoundWidgetsScale* _tmp46_;
		GtkScale* _tmp47_;
		GtkScale* _tmp48_;
		SoundWidgetsScale* _tmp49_;
		GtkScale* _tmp50_;
		GtkScale* _tmp51_;
		SoundWidgetsScale* _tmp52_;
		SoundWidgetsPlayerList* _tmp53_;
		GtkModelButton* _tmp54_;
		SoundServicesVolumeControlPulse* _tmp55_;
		SoundWidgetsScale* _tmp56_;
		GtkScale* _tmp57_;
		GtkScale* _tmp58_;
		SoundWidgetsScale* _tmp59_;
		SoundWidgetsScale* _tmp60_;
		SoundWidgetsScale* _tmp61_;
		GtkScale* _tmp62_;
		GtkScale* _tmp63_;
		_tmp1_ = sound_widgets_player_list_new ();
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->priv->mpris);
		self->priv->mpris = _tmp1_;
		_tmp2_ = self->priv->volume_scale;
		_tmp3_ = self->priv->volume_control;
		_tmp4_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp3_);
		_tmp5_ = _tmp4_;
		sound_widgets_scale_set_active (_tmp2_, !_tmp5_);
		_tmp6_ = self->priv->volume_scale;
		_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = self->priv->volume_control;
		_tmp10_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp9_);
		_tmp11_ = _tmp10_;
		gtk_range_set_value ((GtkRange*) _tmp8_, _tmp11_->volume);
		_tmp12_ = self->priv->volume_scale;
		_tmp13_ = self->priv->volume_scale;
		_tmp14_ = sound_widgets_scale_get_scale_widget (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp15_));
		sound_widgets_scale_set_icon (_tmp12_, _tmp16_);
		sound_indicator_set_max_volume (self);
		_tmp17_ = self->priv->mic_scale;
		_tmp18_ = self->priv->volume_control;
		_tmp19_ = sound_services_volume_control_pulse_get_micMute (_tmp18_);
		_tmp20_ = _tmp19_;
		sound_widgets_scale_set_active (_tmp17_, !_tmp20_);
		_tmp21_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
		g_object_ref_sink (_tmp21_);
		_g_object_unref0 (self->priv->mic_separator);
		self->priv->mic_separator = _tmp21_;
		sound_indicator_update_mic_visibility (self);
		_tmp22_ = g_strdup (_ ("Sound Settings…"));
		_tmp23_ = (GtkModelButton*) gtk_model_button_new ();
		g_object_set (_tmp23_, "text", _tmp22_, NULL);
		_g_free0 (_tmp22_);
		g_object_ref_sink (_tmp23_);
		settings_button = _tmp23_;
		_tmp24_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp24_);
		_g_object_unref0 (self->priv->main_grid);
		self->priv->main_grid = _tmp24_;
		_tmp25_ = self->priv->main_grid;
		_tmp26_ = self->priv->mpris;
		gtk_grid_attach (_tmp25_, (GtkWidget*) _tmp26_, 0, 0, 1, 1);
		_tmp27_ = self->priv->main_grid;
		_tmp28_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
		g_object_ref_sink (_tmp28_);
		_tmp29_ = _tmp28_;
		gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp29_, 0, 1, 1, 1);
		_g_object_unref0 (_tmp29_);
		_tmp30_ = self->priv->main_grid;
		_tmp31_ = self->priv->volume_scale;
		gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 0, 2, 1, 1);
		_tmp32_ = self->priv->main_grid;
		_tmp33_ = self->priv->output_device_manager;
		gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 0, 3, 1, 1);
		_tmp34_ = self->priv->main_grid;
		_tmp35_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
		g_object_ref_sink (_tmp35_);
		_tmp36_ = _tmp35_;
		gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp36_, 0, 4, 1, 1);
		_g_object_unref0 (_tmp36_);
		_tmp37_ = self->priv->main_grid;
		_tmp38_ = self->priv->mic_scale;
		gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 0, 5, 1, 1);
		_tmp39_ = self->priv->main_grid;
		_tmp40_ = self->priv->input_device_manager;
		gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 0, 6, 1, 1);
		_tmp41_ = self->priv->main_grid;
		_tmp42_ = self->priv->mic_separator;
		gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp42_, 0, 7, 1, 1);
		_tmp43_ = self->priv->main_grid;
		_tmp44_ = settings_button;
		gtk_grid_attach (_tmp43_, (GtkWidget*) _tmp44_, 0, 8, 1, 1);
		_tmp45_ = self->priv->mic_scale;
		g_signal_connect_object ((GObject*) _tmp45_, "notify::active", (GCallback) _sound_indicator_on_mic_switch_change_g_object_notify, self, 0);
		_tmp46_ = self->priv->mic_scale;
		_tmp47_ = sound_widgets_scale_get_scale_widget (_tmp46_);
		_tmp48_ = _tmp47_;
		g_signal_connect_object ((GtkRange*) _tmp48_, "value-changed", (GCallback) ____lambda57__gtk_range_value_changed, self, 0);
		_tmp49_ = self->priv->mic_scale;
		_tmp50_ = sound_widgets_scale_get_scale_widget (_tmp49_);
		_tmp51_ = _tmp50_;
		g_signal_connect_object ((GtkWidget*) _tmp51_, "button-release-event", (GCallback) ____lambda58__gtk_widget_button_release_event, self, 0);
		_tmp52_ = self->priv->mic_scale;
		g_signal_connect_object ((GtkWidget*) _tmp52_, "scroll-event", (GCallback) ____lambda59__gtk_widget_scroll_event, self, G_CONNECT_AFTER);
		_tmp53_ = self->priv->mpris;
		g_signal_connect_object (_tmp53_, "close", (GCallback) ____lambda60__sound_widgets_player_list_close, self, 0);
		_tmp54_ = settings_button;
		g_signal_connect_object ((GtkButton*) _tmp54_, "clicked", (GCallback) ____lambda61__gtk_button_clicked, self, 0);
		_tmp55_ = self->priv->volume_control;
		g_signal_connect_object ((GObject*) _tmp55_, "notify::headphone-plugged", (GCallback) ____lambda62__g_object_notify, self, 0);
		_tmp56_ = self->priv->volume_scale;
		_tmp57_ = sound_widgets_scale_get_scale_widget (_tmp56_);
		_tmp58_ = _tmp57_;
		g_signal_connect_object ((GtkWidget*) _tmp58_, "button-release-event", (GCallback) ____lambda63__gtk_widget_button_release_event, self, 0);
		_tmp59_ = self->priv->volume_scale;
		g_signal_connect_object ((GtkWidget*) _tmp59_, "scroll-event", (GCallback) ____lambda64__gtk_widget_scroll_event, self, G_CONNECT_AFTER);
		_tmp60_ = self->priv->volume_scale;
		g_signal_connect_object ((GObject*) _tmp60_, "notify::active", (GCallback) _sound_indicator_on_volume_switch_change_g_object_notify, self, 0);
		_tmp61_ = self->priv->volume_scale;
		_tmp62_ = sound_widgets_scale_get_scale_widget (_tmp61_);
		_tmp63_ = _tmp62_;
		g_signal_connect_object ((GtkRange*) _tmp63_, "value-changed", (GCallback) ____lambda65__gtk_range_value_changed, self, 0);
		_g_object_unref0 (settings_button);
	}
	_tmp64_ = self->priv->main_grid;
	_tmp65_ = _g_object_ref0 ((GtkWidget*) _tmp64_);
	result = _tmp65_;
	return result;
}

static gboolean
sound_indicator_handle_scroll_event (SoundIndicator* self,
                                     GdkEventScroll* e,
                                     gdouble* dir)
{
	gdouble _vala_dir = 0.0;
	gboolean natural_scroll = FALSE;
	GdkInputSource event_source = 0;
	GdkDevice* _tmp0_;
	GdkInputSource _tmp1_;
	GdkInputSource _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_vala_dir = 0.0;
	_tmp0_ = gdk_event_get_source_device ((GdkEvent*) e);
	g_object_get (_tmp0_, "input-source", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	event_source = _tmp2_;
	if (event_source == GDK_SOURCE_MOUSE) {
		gboolean _tmp3_;
		_tmp3_ = self->priv->_natural_scroll_mouse;
		natural_scroll = _tmp3_;
	} else {
		if (event_source == GDK_SOURCE_TOUCHPAD) {
			gboolean _tmp4_;
			_tmp4_ = self->priv->_natural_scroll_touchpad;
			natural_scroll = _tmp4_;
		} else {
			natural_scroll = FALSE;
		}
	}
	switch (e->direction) {
		case GDK_SCROLL_SMOOTH:
		{
			gdouble abs_x = 0.0;
			gdouble abs_y = 0.0;
			abs_x = MAX (fabs (e->delta_x), 0.0001);
			abs_y = MAX (fabs (e->delta_y), 0.0001);
			if ((abs_y / abs_x) > 2.0) {
				self->priv->total_y_delta = self->priv->total_y_delta + e->delta_y;
			} else {
				if ((abs_x / abs_y) > 2.0) {
					self->priv->total_x_delta = self->priv->total_x_delta + e->delta_x;
				}
			}
			break;
		}
		case GDK_SCROLL_UP:
		{
			self->priv->total_y_delta = -1.0;
			break;
		}
		case GDK_SCROLL_DOWN:
		{
			self->priv->total_y_delta = 1.0;
			break;
		}
		case GDK_SCROLL_LEFT:
		{
			self->priv->total_x_delta = -1.0;
			break;
		}
		case GDK_SCROLL_RIGHT:
		{
			self->priv->total_x_delta = 1.0;
			break;
		}
		default:
		{
			break;
		}
	}
	if (fabs (self->priv->total_y_delta) > 0.5) {
		gdouble _tmp5_ = 0.0;
		if (natural_scroll) {
			_tmp5_ = self->priv->total_y_delta;
		} else {
			_tmp5_ = -self->priv->total_y_delta;
		}
		_vala_dir = _tmp5_;
	} else {
		if (fabs (self->priv->total_x_delta) > 0.5) {
			gdouble _tmp6_ = 0.0;
			if (natural_scroll) {
				_tmp6_ = -self->priv->total_x_delta;
			} else {
				_tmp6_ = self->priv->total_x_delta;
			}
			_vala_dir = _tmp6_;
		}
	}
	if (fabs (_vala_dir) > 0.0) {
		self->priv->total_y_delta = 0.0;
		self->priv->total_x_delta = 0.0;
		result = TRUE;
		if (dir) {
			*dir = _vala_dir;
		}
		return result;
	}
	result = FALSE;
	if (dir) {
		*dir = _vala_dir;
	}
	return result;
}

static void
sound_indicator_handle_change (SoundIndicator* self,
                               gdouble change,
                               gboolean is_mic)
{
	gdouble v = 0.0;
	gdouble new_v = 0.0;
	g_return_if_fail (self != NULL);
	if (is_mic) {
		SoundServicesVolumeControlPulse* _tmp0_;
		gdouble _tmp1_;
		gdouble _tmp2_;
		_tmp0_ = self->priv->volume_control;
		_tmp1_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp0_);
		_tmp2_ = _tmp1_;
		v = _tmp2_;
	} else {
		SoundServicesVolumeControlPulse* _tmp3_;
		SoundServicesVolumeControlVolume* _tmp4_;
		SoundServicesVolumeControlVolume* _tmp5_;
		_tmp3_ = self->priv->volume_control;
		_tmp4_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp3_);
		_tmp5_ = _tmp4_;
		v = _tmp5_->volume;
	}
	new_v = CLAMP (v + (SOUND_INDICATOR_VOLUME_STEP_PERCENTAGE * change), 0.0, self->priv->max_volume);
	if (new_v == v) {
		return;
	}
	if (is_mic) {
		SoundServicesVolumeControlPulse* _tmp6_;
		_tmp6_ = self->priv->volume_control;
		sound_services_volume_control_set_mic_volume ((SoundServicesVolumeControl*) _tmp6_, new_v);
	} else {
		SoundServicesVolumeControlVolume* vol = NULL;
		SoundServicesVolumeControlVolume* _tmp7_;
		SoundServicesVolumeControlVolume* _tmp8_;
		SoundServicesVolumeControlVolume* _tmp9_;
		SoundServicesVolumeControlPulse* _tmp10_;
		SoundServicesVolumeControlVolume* _tmp11_;
		_tmp7_ = sound_services_volume_control_volume_new ();
		vol = _tmp7_;
		_tmp8_ = vol;
		_tmp8_->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS;
		_tmp9_ = vol;
		_tmp9_->volume = new_v;
		_tmp10_ = self->priv->volume_control;
		_tmp11_ = vol;
		sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) _tmp10_, _tmp11_);
		_g_object_unref0 (vol);
	}
	sound_indicator_notify_change (self, is_mic);
}

static void
sound_indicator_real_opened (WingpanelIndicator* base)
{
	SoundIndicator * self;
	SoundWidgetsPlayerList* _tmp0_;
	NotifyNotification* _tmp1_;
	GError* _inner_error0_ = NULL;
	self = (SoundIndicator*) base;
	self->priv->open = TRUE;
	_tmp0_ = self->priv->mpris;
	sound_widgets_player_list_update_default_player (_tmp0_);
	_tmp1_ = self->priv->notification;
	if (_tmp1_ != NULL) {
		{
			NotifyNotification* _tmp2_;
			_tmp2_ = self->priv->notification;
			notify_notification_close (_tmp2_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp3_ = e;
			_tmp4_ = _tmp3_->message;
			g_warning ("Indicator.vala:472: Unable to close sound notification: %s", _tmp4_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_object_unref0 (self->priv->notification);
		self->priv->notification = NULL;
	}
}

static void
sound_indicator_real_closed (WingpanelIndicator* base)
{
	SoundIndicator * self;
	self = (SoundIndicator*) base;
	self->priv->open = FALSE;
	_g_object_unref0 (self->priv->notification);
	self->priv->notification = NULL;
}

static void
sound_indicator_show_settings (SoundIndicator* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
	{
		g_app_info_launch_default_for_uri ("settings://sound", NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("Indicator.vala:490: %s\n", _tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SoundIndicator* self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gboolean
__lambda56_ (Block1Data* _data1_)
{
	SoundIndicator* self;
	gboolean notification_showing = FALSE;
	gboolean result;
	self = _data1_->self;
	notification_showing = FALSE;
	if (!self->priv->open) {
		notification_showing = sound_indicator_show_notification (self, _data1_->is_mic);
	}
	if (!notification_showing) {
		ca_proplist* props = NULL;
		ca_proplist* _tmp0_ = NULL;
		ca_proplist* _tmp1_;
		ca_proplist* _tmp2_;
		ca_context* _tmp3_;
		ca_proplist* _tmp4_;
		ca_proplist_create (&_tmp0_);
		_ca_proplist_destroy0 (props);
		props = _tmp0_;
		_tmp1_ = props;
		ca_proplist_sets (_tmp1_, CA_PROP_CANBERRA_CACHE_CONTROL, "volatile");
		_tmp2_ = props;
		ca_proplist_sets (_tmp2_, CA_PROP_EVENT_ID, "audio-volume-change");
		_tmp3_ = self->priv->ca_context;
		_tmp4_ = props;
		ca_context_play_full (_tmp3_, (guint32) 0, _tmp4_, NULL, NULL);
		_ca_proplist_destroy0 (props);
	}
	self->priv->notify_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}

static gboolean
___lambda56__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda56_ (self);
	return result;
}

static void
sound_indicator_notify_change (SoundIndicator* self,
                               gboolean is_mic)
{
	Block1Data* _data1_;
	g_return_if_fail (self != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_data1_->is_mic = is_mic;
	if (self->priv->notify_timeout_id > ((guint) 0)) {
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return;
	}
	self->priv->notify_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda56__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static gboolean
sound_indicator_show_notification (SoundIndicator* self,
                                   gboolean is_mic)
{
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->notification;
	if (_tmp0_ == NULL) {
		NotifyNotification* _tmp1_;
		NotifyNotification* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		_tmp1_ = notify_notification_new ("indicator-sound", "", "");
		_g_object_unref0 (self->priv->notification);
		self->priv->notification = _tmp1_;
		_tmp2_ = self->priv->notification;
		_tmp3_ = g_variant_new_string ("indicator-sound");
		g_variant_ref_sink (_tmp3_);
		_tmp4_ = _tmp3_;
		notify_notification_set_hint (_tmp2_, "x-canonical-private-synchronous", _tmp4_);
		_g_variant_unref0 (_tmp4_);
	}
	_tmp5_ = self->priv->notification;
	if (_tmp5_ != NULL) {
		gchar* icon = NULL;
		NotifyNotification* _tmp12_;
		const gchar* _tmp13_;
		gint32 volume = 0;
		NotifyNotification* _tmp20_;
		GVariant* _tmp21_;
		GVariant* _tmp22_;
		if (is_mic) {
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("audio-input-microphone-symbolic");
			_g_free0 (icon);
			icon = _tmp6_;
		} else {
			SoundWidgetsScale* _tmp7_;
			GtkScale* _tmp8_;
			GtkScale* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp7_ = self->priv->volume_scale;
			_tmp8_ = sound_widgets_scale_get_scale_widget (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp9_));
			_tmp11_ = g_strdup (_tmp10_);
			_g_free0 (icon);
			icon = _tmp11_;
		}
		_tmp12_ = self->priv->notification;
		_tmp13_ = icon;
		notify_notification_update (_tmp12_, "indicator-sound", "", _tmp13_);
		if (is_mic) {
			SoundServicesVolumeControlPulse* _tmp14_;
			gdouble _tmp15_;
			gdouble _tmp16_;
			_tmp14_ = self->priv->volume_control;
			_tmp15_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp14_);
			_tmp16_ = _tmp15_;
			volume = (gint32) round ((_tmp16_ / self->priv->max_volume) * 100.0);
		} else {
			SoundServicesVolumeControlPulse* _tmp17_;
			SoundServicesVolumeControlVolume* _tmp18_;
			SoundServicesVolumeControlVolume* _tmp19_;
			_tmp17_ = self->priv->volume_control;
			_tmp18_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp17_);
			_tmp19_ = _tmp18_;
			volume = (gint32) round ((_tmp19_->volume / self->priv->max_volume) * 100.0);
		}
		_tmp20_ = self->priv->notification;
		_tmp21_ = g_variant_new_int32 (volume);
		g_variant_ref_sink (_tmp21_);
		_tmp22_ = _tmp21_;
		notify_notification_set_hint (_tmp20_, "value", _tmp22_);
		_g_variant_unref0 (_tmp22_);
		{
			NotifyNotification* _tmp23_;
			_tmp23_ = self->priv->notification;
			notify_notification_show (_tmp23_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp24_ = e;
			_tmp25_ = _tmp24_->message;
			g_warning ("Indicator.vala:552: Unable to show sound notification: %s", _tmp25_);
			_g_object_unref0 (self->priv->notification);
			self->priv->notification = NULL;
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (icon);
			return result;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp26_ = FALSE;
			_g_free0 (icon);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp26_;
		}
		_g_free0 (icon);
	} else {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

static void
sound_indicator_update_tooltip (SoundIndicator* self)
{
	gdouble _tmp0_ = 0.0;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* description = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_ = NULL;
	SoundServicesVolumeControlPulse* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gchar* accel_label = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	DisplayWidget* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->volume_control;
	_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = (gdouble) 0;
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
		SoundServicesVolumeControlVolume* _tmp5_;
		SoundServicesVolumeControlVolume* _tmp6_;
		_tmp4_ = self->priv->volume_control;
		_tmp5_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_->volume * 100;
	}
	_tmp7_ = g_strdup_printf (_ ("Volume: %.0f%%"), _tmp0_);
	description = _tmp7_;
	_tmp9_ = self->priv->volume_control;
	_tmp10_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		_tmp8_ = _ ("Middle-click to unmute");
	} else {
		_tmp8_ = _ ("Middle-click to mute");
	}
	_tmp12_ = g_strdup (_tmp8_);
	accel_label = _tmp12_;
	_tmp13_ = accel_label;
	_tmp14_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _tmp13_);
	_g_free0 (accel_label);
	accel_label = _tmp14_;
	_tmp15_ = self->priv->display_widget;
	_tmp16_ = description;
	_tmp17_ = accel_label;
	_tmp18_ = g_strdup_printf ("%s\n%s", _tmp16_, _tmp17_);
	_tmp19_ = _tmp18_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp15_, _tmp19_);
	_g_free0 (_tmp19_);
	_g_free0 (accel_label);
	_g_free0 (description);
}

gboolean
sound_indicator_get_natural_scroll_touchpad (SoundIndicator* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_natural_scroll_touchpad;
	return result;
}

void
sound_indicator_set_natural_scroll_touchpad (SoundIndicator* self,
                                             gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_indicator_get_natural_scroll_touchpad (self);
	if (old_value != value) {
		self->priv->_natural_scroll_touchpad = value;
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY]);
	}
}

gboolean
sound_indicator_get_natural_scroll_mouse (SoundIndicator* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_natural_scroll_mouse;
	return result;
}

void
sound_indicator_set_natural_scroll_mouse (SoundIndicator* self,
                                          gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_indicator_get_natural_scroll_mouse (self);
	if (old_value != value) {
		self->priv->_natural_scroll_mouse = value;
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY]);
	}
}

static void
_sound_indicator_on_volume_change_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	sound_indicator_on_volume_change ((SoundIndicator*) self);
}

static void
_sound_indicator_on_mic_volume_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
	sound_indicator_on_mic_volume_change ((SoundIndicator*) self);
}

static void
_sound_indicator_on_mute_change_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
	sound_indicator_on_mute_change ((SoundIndicator*) self);
}

static void
_sound_indicator_on_mic_mute_change_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	sound_indicator_on_mic_mute_change ((SoundIndicator*) self);
}

static void
_sound_indicator_on_is_playing_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
	sound_indicator_on_is_playing_change ((SoundIndicator*) self);
}

static void
_sound_indicator_update_mic_visibility_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
	sound_indicator_update_mic_visibility ((SoundIndicator*) self);
}

static void
_sound_indicator_update_tooltip_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
	sound_indicator_update_tooltip ((SoundIndicator*) self);
}

static void
_sound_indicator_set_max_volume_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
	sound_indicator_set_max_volume ((SoundIndicator*) self);
}

static void
_sound_indicator___lambda66_ (SoundIndicator* self,
                              GdkEventButton* e)
{
	g_return_if_fail (e != NULL);
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
		SoundServicesVolumeControlPulse* _tmp0_;
		_tmp0_ = self->priv->volume_control;
		sound_services_volume_control_pulse_toggle_mute (_tmp0_);
	}
}

static void
__sound_indicator___lambda66__display_widget_volume_press_event (DisplayWidget* _sender,
                                                                 GdkEventButton* e,
                                                                 gpointer self)
{
	_sound_indicator___lambda66_ ((SoundIndicator*) self, e);
}

static void
_sound_indicator___lambda67_ (SoundIndicator* self,
                              GdkEventButton* e)
{
	g_return_if_fail (e != NULL);
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
		SoundServicesVolumeControlPulse* _tmp0_;
		_tmp0_ = self->priv->volume_control;
		sound_services_volume_control_pulse_toggle_mic_mute (_tmp0_);
	}
}

static void
__sound_indicator___lambda67__display_widget_mic_press_event (DisplayWidget* _sender,
                                                              GdkEventButton* e,
                                                              gpointer self)
{
	_sound_indicator___lambda67_ ((SoundIndicator*) self, e);
}

static void
_sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event (DisplayWidget* _sender,
                                                                                 GdkEventScroll* e,
                                                                                 gpointer self)
{
	sound_indicator_on_volume_icon_scroll_event ((SoundIndicator*) self, e);
}

static void
_sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event (DisplayWidget* _sender,
                                                                           GdkEventScroll* e,
                                                                           gpointer self)
{
	sound_indicator_on_mic_icon_scroll_event ((SoundIndicator*) self, e);
}

static GObject *
sound_indicator_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundIndicator * self;
	GSettings* touchpad_settings = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* mouse_settings = NULL;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	DisplayWidget* _tmp4_;
	SoundServicesVolumeControlPulse* _tmp5_;
	SoundServicesVolumeControlPulse* _tmp6_;
	SoundServicesVolumeControlPulse* _tmp7_;
	SoundServicesVolumeControlPulse* _tmp8_;
	SoundServicesVolumeControlPulse* _tmp9_;
	SoundServicesVolumeControlPulse* _tmp10_;
	SoundServicesVolumeControlPulse* _tmp11_;
	SoundServicesVolumeControlPulse* _tmp12_;
	SoundServicesVolumeControlPulse* _tmp13_;
	SoundWidgetsDeviceManagerWidget* _tmp14_ = NULL;
	SoundWidgetsDeviceManagerWidget* _tmp15_ = NULL;
	GSettings* _tmp16_;
	gchar* locale = NULL;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	DisplayWidget* _tmp19_;
	DisplayWidget* _tmp20_;
	DisplayWidget* _tmp21_;
	SoundServicesVolumeControlPulse* _tmp22_;
	SoundServicesVolumeControlVolume* _tmp23_;
	SoundServicesVolumeControlVolume* _tmp24_;
	const gchar* _tmp25_;
	DisplayWidget* _tmp26_;
	DisplayWidget* _tmp27_;
	SoundWidgetsScale* _tmp28_;
	SoundWidgetsScale* _tmp29_;
	ca_context* _tmp30_;
	ca_context* _tmp31_;
	const gchar* _tmp32_;
	ca_context* _tmp33_;
	parent_class = G_OBJECT_CLASS (sound_indicator_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INDICATOR, SoundIndicator);
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	_tmp0_ = g_settings_new ("org.gnome.desktop.peripherals.touchpad");
	touchpad_settings = _tmp0_;
	_tmp1_ = touchpad_settings;
	g_settings_bind (_tmp1_, "natural-scroll", (GObject*) self, "natural-scroll-touchpad", G_SETTINGS_BIND_DEFAULT);
	_tmp2_ = g_settings_new ("org.gnome.desktop.peripherals.mouse");
	mouse_settings = _tmp2_;
	_tmp3_ = mouse_settings;
	g_settings_bind (_tmp3_, "natural-scroll", (GObject*) self, "natural-scroll-mouse", G_SETTINGS_BIND_DEFAULT);
	wingpanel_indicator_set_visible ((WingpanelIndicator*) self, TRUE);
	_tmp4_ = display_widget_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->display_widget);
	self->priv->display_widget = _tmp4_;
	_tmp5_ = sound_services_volume_control_pulse_new ();
	_g_object_unref0 (self->priv->volume_control);
	self->priv->volume_control = _tmp5_;
	_tmp6_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp6_, "notify::volume", (GCallback) _sound_indicator_on_volume_change_g_object_notify, self, 0);
	_tmp7_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp7_, "notify::mic-volume", (GCallback) _sound_indicator_on_mic_volume_change_g_object_notify, self, 0);
	_tmp8_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp8_, "notify::mute", (GCallback) _sound_indicator_on_mute_change_g_object_notify, self, 0);
	_tmp9_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp9_, "notify::micMute", (GCallback) _sound_indicator_on_mic_mute_change_g_object_notify, self, 0);
	_tmp10_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp10_, "notify::is-playing", (GCallback) _sound_indicator_on_is_playing_change_g_object_notify, self, 0);
	_tmp11_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp11_, "notify::is-listening", (GCallback) _sound_indicator_update_mic_visibility_g_object_notify, self, 0);
	_tmp12_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp12_, "notify::volume", (GCallback) _sound_indicator_update_tooltip_g_object_notify, self, 0);
	_tmp13_ = self->priv->volume_control;
	g_signal_connect_object ((GObject*) _tmp13_, "notify::mute", (GCallback) _sound_indicator_update_tooltip_g_object_notify, self, 0);
	_tmp14_ = sound_widgets_device_manager_widget_new ();
	_tmp14_->is_input_manager = FALSE;
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->output_device_manager);
	self->priv->output_device_manager = _tmp14_;
	_tmp15_ = sound_widgets_device_manager_widget_new ();
	_tmp15_->is_input_manager = TRUE;
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->input_device_manager);
	self->priv->input_device_manager = _tmp15_;
	notify_init ("wingpanel-indicator-sound");
	_tmp16_ = sound_indicator_settings;
	g_signal_connect_object ((GObject*) _tmp16_, "notify::max-volume", (GCallback) _sound_indicator_set_max_volume_g_object_notify, self, 0);
	_tmp17_ = setlocale (LC_MESSAGES, NULL);
	_tmp18_ = g_strdup (_tmp17_);
	locale = _tmp18_;
	_tmp19_ = self->priv->display_widget;
	g_signal_connect_object (_tmp19_, "volume-press-event", (GCallback) __sound_indicator___lambda66__display_widget_volume_press_event, self, 0);
	_tmp20_ = self->priv->display_widget;
	g_signal_connect_object (_tmp20_, "mic-press-event", (GCallback) __sound_indicator___lambda67__display_widget_mic_press_event, self, 0);
	_tmp21_ = self->priv->display_widget;
	_tmp22_ = self->priv->volume_control;
	_tmp23_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = sound_indicator_get_volume_icon (self, _tmp24_->volume);
	display_widget_set_icon_name (_tmp21_, _tmp25_);
	_tmp26_ = self->priv->display_widget;
	g_signal_connect_object (_tmp26_, "volume-scroll-event", (GCallback) _sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event, self, G_CONNECT_AFTER);
	_tmp27_ = self->priv->display_widget;
	g_signal_connect_object (_tmp27_, "mic-scroll-event", (GCallback) _sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event, self, G_CONNECT_AFTER);
	_tmp28_ = sound_widgets_scale_new ("audio-volume-high-symbolic", TRUE, 0.0, self->priv->max_volume, 0.01);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->volume_scale);
	self->priv->volume_scale = _tmp28_;
	_tmp29_ = sound_widgets_scale_new ("audio-input-microphone-symbolic", TRUE, 0.0, 1.0, 0.01);
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (self->priv->mic_scale);
	self->priv->mic_scale = _tmp29_;
	_tmp30_ = ca_gtk_context_get ();
	self->priv->ca_context = _tmp30_;
	_tmp31_ = self->priv->ca_context;
	_tmp32_ = locale;
	ca_context_change_props (_tmp31_, CA_PROP_APPLICATION_NAME, "indicator-sound", CA_PROP_APPLICATION_ID, "wingpanel-indicator-sound", CA_PROP_APPLICATION_NAME, "start-here", CA_PROP_APPLICATION_LANGUAGE, _tmp32_, NULL, NULL);
	_tmp33_ = self->priv->ca_context;
	ca_context_open (_tmp33_);
	_g_free0 (locale);
	_g_object_unref0 (mouse_settings);
	_g_object_unref0 (touchpad_settings);
	return obj;
}

static void
sound_indicator_class_init (SoundIndicatorClass * klass,
                            gpointer klass_data)
{
	GSettings* _tmp0_;
	sound_indicator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SoundIndicator_private_offset);
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) sound_indicator_real_get_display_widget;
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) sound_indicator_real_get_widget;
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) sound_indicator_real_opened;
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) sound_indicator_real_closed;
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_indicator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_indicator_set_property;
	G_OBJECT_CLASS (klass)->constructor = sound_indicator_constructor;
	G_OBJECT_CLASS (klass)->finalize = sound_indicator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY] = g_param_spec_boolean ("natural-scroll-touchpad", "natural-scroll-touchpad", "natural-scroll-touchpad", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY] = g_param_spec_boolean ("natural-scroll-mouse", "natural-scroll-mouse", "natural-scroll-mouse", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	_tmp0_ = g_settings_new ("io.elementary.desktop.wingpanel.sound");
	_g_object_unref0 (sound_indicator_settings);
	sound_indicator_settings = _tmp0_;
}

static void
sound_indicator_instance_init (SoundIndicator * self,
                               gpointer klass)
{
	self->priv = sound_indicator_get_instance_private (self);
	self->priv->open = FALSE;
	self->priv->mute_blocks_sound = FALSE;
	self->priv->max_volume = 1.0;
	self->priv->ca_context = NULL;
	self->priv->total_x_delta = (gdouble) 0;
	self->priv->total_y_delta = (gdouble) 0;
	self->priv->notify_timeout_id = (guint) 0;
}

static void
sound_indicator_finalize (GObject * obj)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INDICATOR, SoundIndicator);
	if (self->priv->sound_was_blocked_timeout_id > ((guint) 0)) {
		g_source_remove (self->priv->sound_was_blocked_timeout_id);
	}
	if (self->priv->notify_timeout_id > ((guint) 0)) {
		g_source_remove (self->priv->notify_timeout_id);
	}
	_g_object_unref0 (self->priv->display_widget);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->mpris);
	_g_object_unref0 (self->priv->volume_scale);
	_g_object_unref0 (self->priv->mic_scale);
	_g_object_unref0 (self->priv->output_device_manager);
	_g_object_unref0 (self->priv->input_device_manager);
	_g_object_unref0 (self->priv->mic_separator);
	_g_object_unref0 (self->priv->notification);
	_g_object_unref0 (self->priv->volume_control);
	G_OBJECT_CLASS (sound_indicator_parent_class)->finalize (obj);
}

static GType
sound_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundIndicator), 0, (GInstanceInitFunc) sound_indicator_instance_init, NULL };
	GType sound_indicator_type_id;
	sound_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "SoundIndicator", &g_define_type_info, 0);
	SoundIndicator_private_offset = g_type_add_instance_private (sound_indicator_type_id, sizeof (SoundIndicatorPrivate));
	return sound_indicator_type_id;
}

GType
sound_indicator_get_type (void)
{
	static volatile gsize sound_indicator_type_id__once = 0;
	if (g_once_init_enter (&sound_indicator_type_id__once)) {
		GType sound_indicator_type_id;
		sound_indicator_type_id = sound_indicator_get_type_once ();
		g_once_init_leave (&sound_indicator_type_id__once, sound_indicator_type_id);
	}
	return sound_indicator_type_id__once;
}

static void
_vala_sound_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_INDICATOR, SoundIndicator);
	switch (property_id) {
		case SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
		g_value_set_boolean (value, sound_indicator_get_natural_scroll_touchpad (self));
		break;
		case SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
		g_value_set_boolean (value, sound_indicator_get_natural_scroll_mouse (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sound_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_INDICATOR, SoundIndicator);
	switch (property_id) {
		case SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
		sound_indicator_set_natural_scroll_touchpad (self, g_value_get_boolean (value));
		break;
		case SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
		sound_indicator_set_natural_scroll_mouse (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	SoundIndicator* indicator = NULL;
	SoundIndicator* _tmp0_;
	WingpanelIndicator* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("Indicator.vala:575: Activating Sound Indicator");
	if (server_type != WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
		result = NULL;
		return result;
	}
	_tmp0_ = sound_indicator_new ();
	indicator = _tmp0_;
	result = (WingpanelIndicator*) indicator;
	return result;
}

