/* DeviceManagerWidget.c generated by valac 0.56.2, the Vala compiler
 * generated from DeviceManagerWidget.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Sean Davis <sean@bluesabre.org>
 */

#include "sound.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib-object.h>

enum  {
	SOUND_WIDGETS_DEVICE_MANAGER_WIDGET_0_PROPERTY,
	SOUND_WIDGETS_DEVICE_MANAGER_WIDGET_NUM_PROPERTIES
};
static GParamSpec* sound_widgets_device_manager_widget_properties[SOUND_WIDGETS_DEVICE_MANAGER_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _SoundWidgetsDeviceManagerWidgetPrivate {
	GtkListBox* device_list;
	GtkScrolledWindow* scrolled_box;
	SoundPulseAudioManager* pam;
};

struct _Block5Data {
	int _ref_count_;
	SoundWidgetsDeviceManagerWidget* self;
	DeviceItem* device_item;
	SoundDevice* device;
};

static gint SoundWidgetsDeviceManagerWidget_private_offset;
static gpointer sound_widgets_device_manager_widget_parent_class = NULL;

static void sound_widgets_device_manager_widget_add_device (SoundWidgetsDeviceManagerWidget* self,
                                                     SoundDevice* device);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda52_ (Block5Data* _data5_);
static void sound_widgets_device_manager_widget_update_preferred_devices (SoundWidgetsDeviceManagerWidget* self,
                                                                   SoundDevice* device);
static void ___lambda52__device_item_activated (DeviceItem* _sender,
                                         gpointer self);
static void __lambda53_ (Block5Data* _data5_);
static void sound_widgets_device_manager_widget_update_showable (SoundWidgetsDeviceManagerWidget* self);
static void ___lambda53__sound_device_removed (SoundDevice* _sender,
                                        gpointer self);
static void __lambda54_ (Block5Data* _data5_);
static void ___lambda54__sound_device_defaulted (SoundDevice* _sender,
                                          gpointer self);
static guint sound_widgets_device_manager_widget_n_visible_items (SoundWidgetsDeviceManagerWidget* self);
static void sound_widgets_device_manager_widget_default_output_changed (SoundWidgetsDeviceManagerWidget* self);
static void sound_widgets_device_manager_widget_default_input_changed (SoundWidgetsDeviceManagerWidget* self);
static GObject * sound_widgets_device_manager_widget_constructor (GType type,
                                                           guint n_construct_properties,
                                                           GObjectConstructParam * construct_properties);
static void _sound_widgets_device_manager_widget_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                                           SoundDevice* dev,
                                                                                           gpointer self);
static void _sound_widgets_device_manager_widget_default_output_changed_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self);
static void _sound_widgets_device_manager_widget_default_input_changed_g_object_notify (GObject* _sender,
                                                                                 GParamSpec* pspec,
                                                                                 gpointer self);
static void sound_widgets_device_manager_widget_finalize (GObject * obj);
static GType sound_widgets_device_manager_widget_get_type_once (void);

static inline gpointer
sound_widgets_device_manager_widget_get_instance_private (SoundWidgetsDeviceManagerWidget* self)
{
	return G_STRUCT_MEMBER_P (self, SoundWidgetsDeviceManagerWidget_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		SoundWidgetsDeviceManagerWidget* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->device_item);
		_g_object_unref0 (_data5_->device);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
__lambda52_ (Block5Data* _data5_)
{
	SoundWidgetsDeviceManagerWidget* self;
	SoundPulseAudioManager* _tmp0_;
	self = _data5_->self;
	_tmp0_ = self->priv->pam;
	sound_pulse_audio_manager_set_default_device (_tmp0_, _data5_->device, NULL, NULL);
	sound_widgets_device_manager_widget_update_preferred_devices (self, _data5_->device);
}

static void
___lambda52__device_item_activated (DeviceItem* _sender,
                                    gpointer self)
{
	__lambda52_ (self);
}

static void
__lambda53_ (Block5Data* _data5_)
{
	SoundWidgetsDeviceManagerWidget* self;
	GtkListBox* _tmp0_;
	DeviceItem* _tmp1_;
	GtkListBox* _tmp2_;
	self = _data5_->self;
	_tmp0_ = self->priv->device_list;
	_tmp1_ = _data5_->device_item;
	gtk_container_remove ((GtkContainer*) _tmp0_, (GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->device_list;
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
	sound_widgets_device_manager_widget_update_showable (self);
}

static void
___lambda53__sound_device_removed (SoundDevice* _sender,
                                   gpointer self)
{
	__lambda53_ (self);
}

static void
__lambda54_ (Block5Data* _data5_)
{
	SoundWidgetsDeviceManagerWidget* self;
	DeviceItem* _tmp0_;
	self = _data5_->self;
	_tmp0_ = _data5_->device_item;
	device_item_set_default (_tmp0_);
	sound_widgets_device_manager_widget_update_preferred_devices (self, _data5_->device);
	sound_widgets_device_manager_widget_update_showable (self);
}

static void
___lambda54__sound_device_defaulted (SoundDevice* _sender,
                                     gpointer self)
{
	__lambda54_ (self);
}

static void
sound_widgets_device_manager_widget_add_device (SoundWidgetsDeviceManagerWidget* self,
                                                SoundDevice* device)
{
	Block5Data* _data5_;
	SoundDevice* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp9_;
	GtkListBoxRow* _tmp10_;
	GtkListBoxRow* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GtkListBoxRow* _tmp20_;
	DeviceItem* _tmp21_;
	GtkListBox* _tmp22_;
	DeviceItem* _tmp23_;
	DeviceItem* _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (device);
	_g_object_unref0 (_data5_->device);
	_data5_->device = _tmp0_;
	_tmp3_ = sound_device_get_input (_data5_->device);
	_tmp4_ = _tmp3_;
	if (_tmp4_ != self->is_input_manager) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = sound_device_get_port_name (_data5_->device);
		_tmp6_ = _tmp5_;
		_tmp2_ = g_strcmp0 (_tmp6_, "analog-output") == 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = sound_device_get_port_name (_data5_->device);
		_tmp8_ = _tmp7_;
		_tmp1_ = g_strcmp0 (_tmp8_, "analog-input") == 0;
	}
	if (_tmp1_) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_tmp9_ = self->priv->device_list;
	_tmp10_ = gtk_list_box_get_row_at_index (_tmp9_, 0);
	_tmp11_ = _g_object_ref0 (_tmp10_);
	row = _tmp11_;
	_tmp12_ = sound_device_get_display_name (_data5_->device);
	_tmp13_ = _tmp12_;
	_tmp14_ = sound_device_get_is_default (_data5_->device);
	_tmp15_ = _tmp14_;
	_tmp16_ = sound_device_get_is_priority (_data5_->device);
	_tmp17_ = _tmp16_;
	_tmp18_ = sound_device_get_icon_name (_data5_->device);
	_tmp19_ = _tmp18_;
	_tmp20_ = row;
	_tmp21_ = device_item_new (_tmp13_, _tmp15_, _tmp17_, _tmp19_, _tmp20_);
	g_object_ref_sink (_tmp21_);
	_data5_->device_item = _tmp21_;
	_tmp22_ = self->priv->device_list;
	_tmp23_ = _data5_->device_item;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = _data5_->device_item;
	g_signal_connect_data (_tmp24_, "activated", (GCallback) ___lambda52__device_item_activated, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	g_signal_connect_data (_data5_->device, "removed", (GCallback) ___lambda53__sound_device_removed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	g_signal_connect_data (_data5_->device, "defaulted", (GCallback) ___lambda54__sound_device_defaulted, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	sound_widgets_device_manager_widget_update_showable (self);
	_g_object_unref0 (row);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}

/**
     * Preferred devices are stored as:
     * {
     *   device_a: last_used_unix_timestamp,
     *   device_b: last_used_unix_timestamp
     * }
     * If a device hasn't been selected in 7 days, it is removed from preferred devices.
     * Device selection happens when the user selects the device, and when the plugin
     * is initialized.
     */
static void
sound_widgets_device_manager_widget_update_preferred_devices (SoundWidgetsDeviceManagerWidget* self,
                                                              SoundDevice* device)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GVariant* preferred_devices = NULL;
	GSettings* _tmp4_;
	GVariant* _tmp5_;
	gint32 now = 0;
	gint32 preferred_expiry = 0;
	GVariantBuilder* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GVariant* dictionary = NULL;
	GVariantBuilder* _tmp29_;
	GVariant* _tmp30_;
	GSettings* _tmp31_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = g_variant_type_new ("a{si}");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	builder = _tmp3_;
	_tmp4_ = sound_indicator_settings;
	_tmp5_ = g_settings_get_value (_tmp4_, "preferred-devices");
	preferred_devices = _tmp5_;
	now = (gint32) (g_get_real_time () / 1000000);
	preferred_expiry = now - (86400 * 7);
	_tmp6_ = builder;
	_tmp7_ = sound_device_get_id (device);
	_tmp8_ = _tmp7_;
	g_variant_builder_add (_tmp6_, "{si}", _tmp8_, now, NULL);
	{
		GVariantIter* _dev_it = NULL;
		GVariant* _tmp9_;
		GVariantIter* _tmp10_;
		GVariant* dev = NULL;
		_tmp9_ = preferred_devices;
		_tmp10_ = g_variant_iter_new (_tmp9_);
		_dev_it = _tmp10_;
		while (TRUE) {
			GVariantIter* _tmp11_;
			GVariant* _tmp12_;
			GVariant* _tmp13_;
			gchar* name = NULL;
			GVariant* _tmp14_;
			GVariant* _tmp15_;
			GVariant* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gint32 last_used = 0;
			GVariant* _tmp20_;
			GVariant* _tmp21_;
			GVariant* _tmp22_;
			gint32 _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			GVariantBuilder* _tmp27_;
			const gchar* _tmp28_;
			_tmp11_ = _dev_it;
			_tmp12_ = g_variant_iter_next_value (_tmp11_);
			_g_variant_unref0 (dev);
			dev = _tmp12_;
			_tmp13_ = dev;
			if (!(_tmp13_ != NULL)) {
				break;
			}
			_tmp14_ = dev;
			_tmp15_ = g_variant_get_child_value (_tmp14_, (gsize) 0);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_variant_get_string (_tmp16_, NULL);
			_tmp18_ = g_strdup (_tmp17_);
			_tmp19_ = _tmp18_;
			_g_variant_unref0 (_tmp16_);
			name = _tmp19_;
			_tmp20_ = dev;
			_tmp21_ = g_variant_get_child_value (_tmp20_, (gsize) 1);
			_tmp22_ = _tmp21_;
			_tmp23_ = g_variant_get_int32 (_tmp22_);
			_g_variant_unref0 (_tmp22_);
			last_used = _tmp23_;
			_tmp24_ = name;
			_tmp25_ = sound_device_get_id (device);
			_tmp26_ = _tmp25_;
			if (g_strcmp0 (_tmp24_, _tmp26_) == 0) {
				_g_free0 (name);
				continue;
			}
			if (last_used < preferred_expiry) {
				_g_free0 (name);
				continue;
			}
			_tmp27_ = builder;
			_tmp28_ = name;
			g_variant_builder_add (_tmp27_, "{si}", _tmp28_, last_used, NULL);
			_g_free0 (name);
		}
		_g_variant_unref0 (dev);
		_g_variant_iter_free0 (_dev_it);
	}
	_tmp29_ = builder;
	_tmp30_ = g_variant_builder_end (_tmp29_);
	g_variant_ref_sink (_tmp30_);
	dictionary = _tmp30_;
	sound_device_set_is_priority (device, TRUE);
	_tmp31_ = sound_indicator_settings;
	g_settings_set_value (_tmp31_, "preferred-devices", dictionary);
	_g_variant_unref0 (dictionary);
	_g_variant_unref0 (preferred_devices);
	_g_variant_builder_unref0 (builder);
}

static guint
sound_widgets_device_manager_widget_n_visible_items (SoundWidgetsDeviceManagerWidget* self)
{
	guint n = 0U;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	n = (guint) 0;
	_tmp0_ = self->priv->device_list;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = _tmp1_;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			GtkWidget* device = NULL;
			device = (GtkWidget*) device_it->data;
			{
				GtkWidget* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_;
				_tmp2_ = device;
				_tmp3_ = gtk_widget_get_visible (_tmp2_);
				_tmp4_ = _tmp3_;
				if (_tmp4_) {
					guint _tmp5_;
					_tmp5_ = n;
					n = _tmp5_ + 1;
				}
			}
		}
		(device_collection == NULL) ? NULL : (device_collection = (g_list_free (device_collection), NULL));
	}
	result = n;
	return result;
}

static void
sound_widgets_device_manager_widget_update_showable (SoundWidgetsDeviceManagerWidget* self)
{
	g_return_if_fail (self != NULL);
	if (sound_widgets_device_manager_widget_n_visible_items (self) <= ((guint) 1)) {
		GtkScrolledWindow* _tmp0_;
		_tmp0_ = self->priv->scrolled_box;
		gtk_widget_hide ((GtkWidget*) _tmp0_);
	} else {
		GtkScrolledWindow* _tmp1_;
		_tmp1_ = self->priv->scrolled_box;
		gtk_widget_show ((GtkWidget*) _tmp1_);
	}
}

static void
sound_widgets_device_manager_widget_default_output_changed (SoundWidgetsDeviceManagerWidget* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	SoundDevice* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pam;
	_tmp1_ = sound_pulse_audio_manager_get_default_output (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit_by_name (_tmp2_, "defaulted");
}

static void
sound_widgets_device_manager_widget_default_input_changed (SoundWidgetsDeviceManagerWidget* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	SoundDevice* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pam;
	_tmp1_ = sound_pulse_audio_manager_get_default_input (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit_by_name (_tmp2_, "defaulted");
}

SoundWidgetsDeviceManagerWidget*
sound_widgets_device_manager_widget_construct (GType object_type)
{
	SoundWidgetsDeviceManagerWidget * self = NULL;
	self = (SoundWidgetsDeviceManagerWidget*) g_object_new (object_type, NULL);
	return self;
}

SoundWidgetsDeviceManagerWidget*
sound_widgets_device_manager_widget_new (void)
{
	return sound_widgets_device_manager_widget_construct (SOUND_WIDGETS_TYPE_DEVICE_MANAGER_WIDGET);
}

static void
_sound_widgets_device_manager_widget_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                                      SoundDevice* dev,
                                                                                      gpointer self)
{
	sound_widgets_device_manager_widget_add_device ((SoundWidgetsDeviceManagerWidget*) self, dev);
}

static void
_sound_widgets_device_manager_widget_default_output_changed_g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self)
{
	sound_widgets_device_manager_widget_default_output_changed ((SoundWidgetsDeviceManagerWidget*) self);
}

static void
_sound_widgets_device_manager_widget_default_input_changed_g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self)
{
	sound_widgets_device_manager_widget_default_input_changed ((SoundWidgetsDeviceManagerWidget*) self);
}

static GObject *
sound_widgets_device_manager_widget_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundWidgetsDeviceManagerWidget * self;
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp1_;
	SoundPulseAudioManager* _tmp2_;
	SoundPulseAudioManager* _tmp3_;
	SoundPulseAudioManager* _tmp4_;
	GtkListBox* _tmp5_ = NULL;
	GtkScrolledWindow* _tmp6_ = NULL;
	GtkScrolledWindow* _tmp7_;
	GtkListBox* _tmp8_;
	GtkScrolledWindow* _tmp9_;
	parent_class = G_OBJECT_CLASS (sound_widgets_device_manager_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_DEVICE_MANAGER_WIDGET, SoundWidgetsDeviceManagerWidget);
	_tmp0_ = sound_pulse_audio_manager_get_default ();
	self->priv->pam = _tmp0_;
	_tmp1_ = self->priv->pam;
	g_signal_connect_object (_tmp1_, "new-device", (GCallback) _sound_widgets_device_manager_widget_add_device_sound_pulse_audio_manager_new_device, self, 0);
	_tmp2_ = self->priv->pam;
	g_signal_connect_object ((GObject*) _tmp2_, "notify::default-output", (GCallback) _sound_widgets_device_manager_widget_default_output_changed_g_object_notify, self, 0);
	_tmp3_ = self->priv->pam;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::default-input", (GCallback) _sound_widgets_device_manager_widget_default_input_changed_g_object_notify, self, 0);
	_tmp4_ = self->priv->pam;
	sound_pulse_audio_manager_start (_tmp4_);
	_tmp5_ = (GtkListBox*) gtk_list_box_new ();
	gtk_list_box_set_activate_on_single_click (_tmp5_, TRUE);
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->device_list);
	self->priv->device_list = _tmp5_;
	_tmp6_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set (_tmp6_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	gtk_scrolled_window_set_propagate_natural_height (_tmp6_, TRUE);
	gtk_scrolled_window_set_max_content_height (_tmp6_, 256);
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, TRUE);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->scrolled_box);
	self->priv->scrolled_box = _tmp6_;
	_tmp7_ = self->priv->scrolled_box;
	_tmp8_ = self->priv->device_list;
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
	_tmp9_ = self->priv->scrolled_box;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp9_, 0, 1, 1, 1);
	sound_widgets_device_manager_widget_update_showable (self);
	return obj;
}

static void
sound_widgets_device_manager_widget_class_init (SoundWidgetsDeviceManagerWidgetClass * klass,
                                                gpointer klass_data)
{
	sound_widgets_device_manager_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SoundWidgetsDeviceManagerWidget_private_offset);
	G_OBJECT_CLASS (klass)->constructor = sound_widgets_device_manager_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = sound_widgets_device_manager_widget_finalize;
}

static void
sound_widgets_device_manager_widget_instance_init (SoundWidgetsDeviceManagerWidget * self,
                                                   gpointer klass)
{
	self->priv = sound_widgets_device_manager_widget_get_instance_private (self);
}

static void
sound_widgets_device_manager_widget_finalize (GObject * obj)
{
	SoundWidgetsDeviceManagerWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_DEVICE_MANAGER_WIDGET, SoundWidgetsDeviceManagerWidget);
	_g_object_unref0 (self->priv->device_list);
	_g_object_unref0 (self->priv->scrolled_box);
	G_OBJECT_CLASS (sound_widgets_device_manager_widget_parent_class)->finalize (obj);
}

static GType
sound_widgets_device_manager_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundWidgetsDeviceManagerWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_widgets_device_manager_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundWidgetsDeviceManagerWidget), 0, (GInstanceInitFunc) sound_widgets_device_manager_widget_instance_init, NULL };
	GType sound_widgets_device_manager_widget_type_id;
	sound_widgets_device_manager_widget_type_id = g_type_register_static (gtk_grid_get_type (), "SoundWidgetsDeviceManagerWidget", &g_define_type_info, 0);
	SoundWidgetsDeviceManagerWidget_private_offset = g_type_add_instance_private (sound_widgets_device_manager_widget_type_id, sizeof (SoundWidgetsDeviceManagerWidgetPrivate));
	return sound_widgets_device_manager_widget_type_id;
}

GType
sound_widgets_device_manager_widget_get_type (void)
{
	static volatile gsize sound_widgets_device_manager_widget_type_id__once = 0;
	if (g_once_init_enter (&sound_widgets_device_manager_widget_type_id__once)) {
		GType sound_widgets_device_manager_widget_type_id;
		sound_widgets_device_manager_widget_type_id = sound_widgets_device_manager_widget_get_type_once ();
		g_once_init_leave (&sound_widgets_device_manager_widget_type_id__once, sound_widgets_device_manager_widget_type_id);
	}
	return sound_widgets_device_manager_widget_type_id__once;
}

