/* DisplayWidget.c generated by valac 0.56.2, the Vala compiler
 * generated from DisplayWidget.vala, do not modify */

/*
* Copyright (c) 2016-2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "sound.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>

enum  {
	DISPLAY_WIDGET_0_PROPERTY,
	DISPLAY_WIDGET_SHOW_MIC_PROPERTY,
	DISPLAY_WIDGET_MIC_MUTED_PROPERTY,
	DISPLAY_WIDGET_ICON_NAME_PROPERTY,
	DISPLAY_WIDGET_NUM_PROPERTIES
};
static GParamSpec* display_widget_properties[DISPLAY_WIDGET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	DISPLAY_WIDGET_VOLUME_SCROLL_EVENT_SIGNAL,
	DISPLAY_WIDGET_MIC_SCROLL_EVENT_SIGNAL,
	DISPLAY_WIDGET_VOLUME_PRESS_EVENT_SIGNAL,
	DISPLAY_WIDGET_MIC_PRESS_EVENT_SIGNAL,
	DISPLAY_WIDGET_NUM_SIGNALS
};
static guint display_widget_signals[DISPLAY_WIDGET_NUM_SIGNALS] = {0};

struct _DisplayWidgetPrivate {
	gboolean _show_mic;
	gboolean _mic_muted;
	gchar* _icon_name;
};

struct _Block2Data {
	int _ref_count_;
	DisplayWidget* self;
	GtkSpinner* mic_icon;
	GtkStyleContext* mic_style_context;
};

static gint DisplayWidget_private_offset;
static gpointer display_widget_parent_class = NULL;

static GObject * display_widget_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _display_widget___lambda4_ (Block2Data* _data2_,
                                     GdkEventScroll* e);
static gboolean __display_widget___lambda4__gtk_widget_scroll_event (GtkWidget* _sender,
                                                              GdkEventScroll* event,
                                                              gpointer self);
static gboolean _display_widget___lambda5_ (Block2Data* _data2_,
                                     GdkEventButton* e);
static gboolean __display_widget___lambda5__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                    GdkEventButton* event,
                                                                    gpointer self);
static void _display_widget___lambda6_ (Block2Data* _data2_);
static void __display_widget___lambda6__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self);
static void display_widget_finalize (GObject * obj);
static GType display_widget_get_type_once (void);
static void _vala_display_widget_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_display_widget_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
display_widget_get_instance_private (DisplayWidget* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayWidget_private_offset);
}

DisplayWidget*
display_widget_construct (GType object_type)
{
	DisplayWidget * self = NULL;
	self = (DisplayWidget*) g_object_new (object_type, NULL);
	return self;
}

DisplayWidget*
display_widget_new (void)
{
	return display_widget_construct (TYPE_DISPLAY_WIDGET);
}

gboolean
display_widget_get_show_mic (DisplayWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_mic;
	return result;
}

void
display_widget_set_show_mic (DisplayWidget* self,
                             gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = display_widget_get_show_mic (self);
	if (old_value != value) {
		self->priv->_show_mic = value;
		g_object_notify_by_pspec ((GObject *) self, display_widget_properties[DISPLAY_WIDGET_SHOW_MIC_PROPERTY]);
	}
}

gboolean
display_widget_get_mic_muted (DisplayWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_mic_muted;
	return result;
}

void
display_widget_set_mic_muted (DisplayWidget* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = display_widget_get_mic_muted (self);
	if (old_value != value) {
		self->priv->_mic_muted = value;
		g_object_notify_by_pspec ((GObject *) self, display_widget_properties[DISPLAY_WIDGET_MIC_MUTED_PROPERTY]);
	}
}

const gchar*
display_widget_get_icon_name (DisplayWidget* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

void
display_widget_set_icon_name (DisplayWidget* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = display_widget_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_widget_properties[DISPLAY_WIDGET_ICON_NAME_PROPERTY]);
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		DisplayWidget* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->mic_style_context);
		_g_object_unref0 (_data2_->mic_icon);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_display_widget___lambda4_ (Block2Data* _data2_,
                            GdkEventScroll* e)
{
	DisplayWidget* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean result;
	self = _data2_->self;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp1_ = self->priv->_show_mic;
	if (_tmp1_) {
		GtkSpinner* _tmp2_;
		GtkSpinner* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		_tmp2_ = _data2_->mic_icon;
		_tmp3_ = _data2_->mic_icon;
		_tmp4_ = gtk_widget_get_margin_end ((GtkWidget*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp0_ = e->x < ((gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) _tmp2_) + _tmp5_));
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		g_signal_emit (self, display_widget_signals[DISPLAY_WIDGET_MIC_SCROLL_EVENT_SIGNAL], 0, e);
	} else {
		g_signal_emit (self, display_widget_signals[DISPLAY_WIDGET_VOLUME_SCROLL_EVENT_SIGNAL], 0, e);
	}
	result = TRUE;
	return result;
}

static gboolean
__display_widget___lambda4__gtk_widget_scroll_event (GtkWidget* _sender,
                                                     GdkEventScroll* event,
                                                     gpointer self)
{
	gboolean result;
	result = _display_widget___lambda4_ (self, event);
	return result;
}

static gboolean
_display_widget___lambda5_ (Block2Data* _data2_,
                            GdkEventButton* e)
{
	DisplayWidget* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean result;
	self = _data2_->self;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp1_ = self->priv->_show_mic;
	if (_tmp1_) {
		GtkSpinner* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = _data2_->mic_icon;
		_tmp3_ = gtk_widget_get_margin_end ((GtkWidget*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = e->x < ((gdouble) (24 + _tmp4_));
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		g_signal_emit (self, display_widget_signals[DISPLAY_WIDGET_MIC_PRESS_EVENT_SIGNAL], 0, e);
	} else {
		g_signal_emit (self, display_widget_signals[DISPLAY_WIDGET_VOLUME_PRESS_EVENT_SIGNAL], 0, e);
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
__display_widget___lambda5__gtk_widget_button_press_event (GtkWidget* _sender,
                                                           GdkEventButton* event,
                                                           gpointer self)
{
	gboolean result;
	result = _display_widget___lambda5_ (self, event);
	return result;
}

static void
_display_widget___lambda6_ (Block2Data* _data2_)
{
	DisplayWidget* self;
	gboolean _tmp0_;
	self = _data2_->self;
	_tmp0_ = self->priv->_mic_muted;
	if (_tmp0_) {
		GtkStyleContext* _tmp1_;
		_tmp1_ = _data2_->mic_style_context;
		gtk_style_context_add_class (_tmp1_, "disabled");
	} else {
		GtkStyleContext* _tmp2_;
		_tmp2_ = _data2_->mic_style_context;
		gtk_style_context_remove_class (_tmp2_, "disabled");
	}
}

static void
__display_widget___lambda6__g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self)
{
	_display_widget___lambda6_ (self);
}

static GObject *
display_widget_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayWidget * self;
	Block2Data* _data2_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkImage* volume_icon = NULL;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkSpinner* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkSpinner* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkCssProvider* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkRevealer* mic_revealer = NULL;
	GtkRevealer* _tmp12_;
	GtkRevealer* _tmp13_;
	GtkRevealer* _tmp14_;
	GtkSpinner* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkImage* _tmp17_;
	GtkImage* _tmp18_;
	GtkRevealer* _tmp19_;
	parent_class = G_OBJECT_CLASS (display_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DISPLAY_WIDGET, DisplayWidget);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	_tmp1_ = provider;
	gtk_css_provider_load_from_resource (_tmp1_, "io/elementary/wingpanel/sound/indicator.css");
	_tmp2_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp2_);
	volume_icon = _tmp2_;
	_tmp3_ = volume_icon;
	gtk_image_set_pixel_size (_tmp3_, 24);
	_tmp4_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp4_);
	_data2_->mic_icon = _tmp4_;
	_tmp5_ = _data2_->mic_icon;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 18);
	_tmp6_ = _data2_->mic_icon;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	_tmp8_ = _g_object_ref0 (_tmp7_);
	_data2_->mic_style_context = _tmp8_;
	_tmp9_ = _data2_->mic_style_context;
	_tmp10_ = provider;
	gtk_style_context_add_provider (_tmp9_, (GtkStyleProvider*) _tmp10_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp11_ = _data2_->mic_style_context;
	gtk_style_context_add_class (_tmp11_, "mic-icon");
	_tmp12_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp12_);
	mic_revealer = _tmp12_;
	_tmp13_ = mic_revealer;
	gtk_revealer_set_transition_type (_tmp13_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
	_tmp14_ = mic_revealer;
	_tmp15_ = _data2_->mic_icon;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	_tmp16_ = mic_revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp16_);
	_tmp17_ = volume_icon;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp17_);
	g_signal_connect_data ((GtkWidget*) self, "scroll-event", (GCallback) __display_widget___lambda4__gtk_widget_scroll_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	g_signal_connect_data ((GtkWidget*) self, "button-press-event", (GCallback) __display_widget___lambda5__gtk_widget_button_press_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp18_ = volume_icon;
	g_object_bind_property_with_closures ((GObject*) self, "icon-name", (GObject*) _tmp18_, "icon-name", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp19_ = mic_revealer;
	g_object_bind_property_with_closures ((GObject*) self, "show-mic", (GObject*) _tmp19_, "reveal-child", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_signal_connect_data ((GObject*) self, "notify::mic-muted", (GCallback) __display_widget___lambda6__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_g_object_unref0 (mic_revealer);
	_g_object_unref0 (volume_icon);
	_g_object_unref0 (provider);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
display_widget_class_init (DisplayWidgetClass * klass,
                           gpointer klass_data)
{
	display_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_display_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = display_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_WIDGET_SHOW_MIC_PROPERTY, display_widget_properties[DISPLAY_WIDGET_SHOW_MIC_PROPERTY] = g_param_spec_boolean ("show-mic", "show-mic", "show-mic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_WIDGET_MIC_MUTED_PROPERTY, display_widget_properties[DISPLAY_WIDGET_MIC_MUTED_PROPERTY] = g_param_spec_boolean ("mic-muted", "mic-muted", "mic-muted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_WIDGET_ICON_NAME_PROPERTY, display_widget_properties[DISPLAY_WIDGET_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	display_widget_signals[DISPLAY_WIDGET_VOLUME_SCROLL_EVENT_SIGNAL] = g_signal_new ("volume-scroll-event", TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
	display_widget_signals[DISPLAY_WIDGET_MIC_SCROLL_EVENT_SIGNAL] = g_signal_new ("mic-scroll-event", TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
	display_widget_signals[DISPLAY_WIDGET_VOLUME_PRESS_EVENT_SIGNAL] = g_signal_new ("volume-press-event", TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
	display_widget_signals[DISPLAY_WIDGET_MIC_PRESS_EVENT_SIGNAL] = g_signal_new ("mic-press-event", TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
}

static void
display_widget_instance_init (DisplayWidget * self,
                              gpointer klass)
{
	self->priv = display_widget_get_instance_private (self);
}

static void
display_widget_finalize (GObject * obj)
{
	DisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DISPLAY_WIDGET, DisplayWidget);
	_g_free0 (self->priv->_icon_name);
	G_OBJECT_CLASS (display_widget_parent_class)->finalize (obj);
}

static GType
display_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayWidget), 0, (GInstanceInitFunc) display_widget_instance_init, NULL };
	GType display_widget_type_id;
	display_widget_type_id = g_type_register_static (gtk_grid_get_type (), "DisplayWidget", &g_define_type_info, 0);
	DisplayWidget_private_offset = g_type_add_instance_private (display_widget_type_id, sizeof (DisplayWidgetPrivate));
	return display_widget_type_id;
}

GType
display_widget_get_type (void)
{
	static volatile gsize display_widget_type_id__once = 0;
	if (g_once_init_enter (&display_widget_type_id__once)) {
		GType display_widget_type_id;
		display_widget_type_id = display_widget_get_type_once ();
		g_once_init_leave (&display_widget_type_id__once, display_widget_type_id);
	}
	return display_widget_type_id__once;
}

static void
_vala_display_widget_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	DisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DISPLAY_WIDGET, DisplayWidget);
	switch (property_id) {
		case DISPLAY_WIDGET_SHOW_MIC_PROPERTY:
		g_value_set_boolean (value, display_widget_get_show_mic (self));
		break;
		case DISPLAY_WIDGET_MIC_MUTED_PROPERTY:
		g_value_set_boolean (value, display_widget_get_mic_muted (self));
		break;
		case DISPLAY_WIDGET_ICON_NAME_PROPERTY:
		g_value_set_string (value, display_widget_get_icon_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_display_widget_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	DisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DISPLAY_WIDGET, DisplayWidget);
	switch (property_id) {
		case DISPLAY_WIDGET_SHOW_MIC_PROPERTY:
		display_widget_set_show_mic (self, g_value_get_boolean (value));
		break;
		case DISPLAY_WIDGET_MIC_MUTED_PROPERTY:
		display_widget_set_mic_muted (self, g_value_get_boolean (value));
		break;
		case DISPLAY_WIDGET_ICON_NAME_PROPERTY:
		display_widget_set_icon_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

